/* $Id: forms.h,v 1.21 2010/09/10 22:55:50 lamonte Exp $
 *
 * forms.h
 *
 * Additional acknowledgements, news, and updates to the Qodem Project
 * are available at http://qodem.sourceforge.net .
 *
 * This module is licensed under the GNU General Public License Version 2.
 * Please see the file "COPYING" in this directory for more information
 * about the GNU General Public License Version 2.
 *
 *     Copyright (C) 2003  Kevin Lamonte
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 */

#ifndef __FORMS_H__
#define __FORMS_H__

/* Includes --------------------------------------------------------------- */

#include <sys/stat.h>			/* stat() */
#include "modem.h"			/* BAUD_RATE, PARITY, etc. */

/* Defines ---------------------------------------------------------------- */

/* File information is stored in one of these */
struct file_info {
	char * name;
	struct stat fstats;
};

/* Globals ---------------------------------------------------------------- */

/* Functions -------------------------------------------------------------- */

extern int notify_prompt_form(const char * message, const char * prompt, const char * status_prompt, const Q_BOOL visible_cursor, const double timeout, const char * allowed_chars);
extern void notify_form(const char * message, const double timeout);
extern char * save_form(const char * title, char * initial_value, const Q_BOOL is_directory, const Q_BOOL warn_overwrite);
extern struct file_info * view_directory(const char * initial_directory, const char * filter);
extern struct file_info * batch_entry_window(const char * initial_directory, const Q_BOOL zmodem);

/* Prompt for new communication settings.  Returns true if the user changed something. */
extern Q_BOOL comm_settings_form(const char * title, BAUD_RATE * baud, DATA_BITS * data_bits, PARITY * parity, STOP_BITS * stop_bits, Q_BOOL * xonxoff, Q_BOOL * rtscts);

/* Compose key function */
extern int compose_key();

#endif /* __FORMS_H__ */
